/*
This function was taken from "lcc, A Retargetable Compiler for ANSI C",
hereafter referred to as "this software" or "lcc software".  The only
modification to this function is the include of <string.h> to get the strchr
prototype.  The following text is the copyright notice for the lcc software:

The authors of this software are Christopher W. Fraser and
David R. Hanson.

Copyright (c) 1991,1992,1993,1994,1995,1996,1997,1998 by AT&T,
Christopher W. Fraser, and David R. Hanson. All Rights Reserved.

Permission to use, copy, modify, and distribute this software for any
purpose, subject to the provisions described below, without fee is
hereby granted, provided that this entire notice is included in all
copies of any software that is or includes a copy or modification of
this software and in all copies of the supporting documentation for
such software.

THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED
WARRANTY. IN PARTICULAR, NEITHER THE AUTHORS NOR AT&T MAKE ANY
REPRESENTATION OR WARRANTY OF ANY KIND CONCERNING THE MERCHANTABILITY
OF THIS SOFTWARE OR ITS FITNESS FOR ANY PARTICULAR PURPOSE.


lcc is not public-domain software, shareware, and it is not protected
by a `copyleft' agreement, like the code from the Free Software
Foundation.

lcc is available free for your personal research and instructional use
under the `fair use' provisions of the copyright law. You may, however,
redistribute lcc in whole or in part provided you acknowledge its
source and include this CPYRIGHT file. You may, for example, include
the distribution in a CDROM of free software, provided you charge only
for the media, or mirror the distribution files at your site.

You may not sell lcc or any product derived from it in which it is a
significant part of the value of the product. Using the lcc front end
to build a C syntax checker is an example of this kind of product.

You may use parts of lcc in products as long as you charge for only
those components that are entirely your own and you acknowledge the use
of lcc clearly in all product documentation and distribution media. You
must state clearly that your product uses or is based on parts of lcc
and that lcc is available free of charge. You must also request that
bug reports on your product be reported to you. Using the lcc front
end to build a C compiler for the Motorola 88000 chip and charging for
and distributing only the 88000 code generator is an example of this
kind of product.

Using parts of lcc in other products is more problematic. For example,
using parts of lcc in a C++ compiler could save substantial time and
effort and therefore contribute significantly to the profitability of
the product. This kind of use, or any use where others stand to make a
profit from what is primarily our work, requires a license agreement
with Addison-Wesley.  Per-copy and unlimited use licenses are
available; for more information, contact

        J. Carter Shanklin
        Addison Wesley Longman, Inc. 
        2725 Sand Hill Rd.
        Menlo Park, CA 94025
        650/854-0300 x2478 FAX: 650/614-2930 jcs@awl.com
-----
Chris Fraser / cwfraser@microsoft.com
David Hanson / drh@microsoft.com
$Revision: 1.2 $ $Date: 1999/04/06 16:13:54 $
*/
#include        <stdio.h>
#include        <string.h>

#define EPR                 fprintf(stderr,
#define ERR(str, chr)       if(opterr){EPR "%s%c\n", str, chr);}

int     opterr = 1;
int     optind = 1;
int     optopt;
char    *optarg;
char    *strchr();

int getopt (int argc, char *const argv[], const char *opts)
{
        static int sp = 1;
        register c;
        register char *cp;

        if (sp == 1)
                if (optind >= argc ||
                   argv[optind][0] != '-' || argv[optind][1] == '\0')
                        return -1;
                else if (strcmp(argv[optind], "--") == 0) {
                        optind++;
                        return -1;
                }
        optopt = c = (int) argv[optind][sp];
        if (c == ':' || (cp=strchr(opts, c)) == 0) {
                ERR (": illegal option -- ", c);
                if (argv[optind][++sp] == '\0') {
                        optind++;
                        sp = 1;
                }
                return '?';
        }
        if (*++cp == ':') {
                if (argv[optind][sp+1] != '\0')
                        optarg = &argv[optind++][sp+1];
                else if (++optind >= argc) {
                        ERR (": option requires an argument -- ", c);
                        sp = 1;
                        return '?';
                } else
                        optarg = argv[optind++];
                sp = 1;
        } else {
                if (argv[optind][++sp] == '\0') {
                        sp = 1;
                        optind++;
                }
                optarg = 0;
        }
        return c;
}
