/* FILE: strUtilities.h
 *
 * PROGRAM: Utility module
 *
 * DESCRIPTION: This file contains header information for the strUtilities
 *     module.
 *
 * RCS INFO:
 *
 *	$Id: strUtilities.h,v 1.2 1999/02/03 18:56:13 jarva Exp $
 *
 *	$Log: strUtilities.h,v $
 *	Revision 1.2  1999/02/03 18:56:13  jarva
 *	Promotion from 1.1.0 branch.
 *
 * Revision 1.1.0.2  1999/01/21  19:23:42  stroup
 * Added prototypes for strNextToken, strLeftTrim, strRightTrim, and strrev.
 *
 * Revision 1.1.0.1  1999/01/14  19:37:12  jarva
 * Added prototype for strDestructor.
 *
 * Revision 1.1  1999/01/06  21:10:54  ToolsDev
 * Initial revision from prototype baseline.
 *
 *
*/
#ifndef _strUtilities_header
#define _strUtilities_header

/* INCLUDED FILES: the following included files are here because of
 *     dependencies that exist within this header file.
*/
#include <stdio.h>
#include <string.h>

/* ---------------------------------------------------------------------*/

/* DATA DECLARATIONS & TYPEDEFS:
 *
*/
	/* NONE */

/* ---------------------------------------------------------------------*/

/* EXTERN VARIABLES: the following variables may be used in other files.
 *    They are defined in strUtilities.c.
*/
	/* NONE */


/* ---------------------------------------------------------------------*/

/* EXTERN PROTOTYPES: the following prototypes are for functions defined
 *     in strUtilities.c but which are intended for use 
 *     elsewhere.
*/
void strInitialization( int debugFlag, int verboseFlag, int noExit,
		FILE *pDebugFile, FILE *pUserMessages );
int strToUpStrcmp (const char *s1, const char *s2);
char *strNextToken (char *string, char *delimiter);
char *strLeftTrim (char *s);
char *strRightTrim (char *s);
char *strrev (char *s);
void *strDestructor(void *pStr);

#endif 
